Attribute VB_Name = "codeButtons"
Option Explicit

Type Button
   Left As Long
   Top As Long
   width As Long
   height As Long
   Status As Byte '0=up; 1=click depressed; 2=toggled down
   Style As Byte '0=img,cap,bck; 1=cap; 2 = bck,cap
   Enabled As Integer
   Caption As String
   capX As Long
   capY As Long
   ImgX As Long
   ImgY As Long
   backcolor As Long
   ToolBarIndex As Integer 'to support multiple toolbars/containers
   DisableStyle As Integer '2=grey out from backcolor edges, 3=grey out black pixels
End Type

Global gBtns(40) As Button
Global gBtnImg(40) As Object
Global BackObj As Object
Global gTwips As Integer

Declare Function GetTickCount Lib "Kernel32" () As Long
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Function BtnDown(DrawObj As Object, Btn As Button, ImageIdx As Integer, BackObj As Object, Optional BackUp) As Integer
    Dim ImgX As Long, ImgY As Long, ImageTypePoint As Integer
    Dim StartTime As Long, checkit As Integer
    
    gTwips = Screen.TwipsPerPixelX

    If Btn.Enabled = False Then
        BtnDown = -1 'no button called
        Exit Function
    End If
   
    If ImageIdx < 0 Then
        DrawObj.Line (Btn.Left, Btn.Top)-Step(Btn.width, Btn.height), Btn.backcolor, BF 'plain colored button
    Else
        ImageTypePoint = 0 '(fix later with states)
        'draw background
        DrawObj.PaintPicture BackObj.Picture, Btn.Left + gTwips, Btn.Top + gTwips, Btn.width - gTwips, Btn.height - gTwips, 0, 0, Btn.width - gTwips, Btn.height - gTwips
    End If
    
    'draw caption
    DrawObj.CurrentY = Btn.capY + gTwips
    DrawObj.CurrentX = Btn.capX + gTwips
    DrawObj.Print Btn.Caption
     
    'draw icon
    If Btn.Style = 0 Then MutateBmp mode:=4, Dest:=DrawObj, Src:=gBtnImg(ImageIdx), destX:=Btn.ImgX + 1, destY:=Btn.ImgY + 1, BckColor:=&HC0C0C0
   
    'draw border
    DrawObj.Line (Btn.Left, Btn.Top)-Step(Btn.width, Btn.height), &HC0C0C0, B
    DrawObj.Line (Btn.Left + gTwips, Btn.Top + gTwips)-Step(Btn.width - gTwips, Btn.height - gTwips), &H0, B
    'draw dark
    'right
    DrawObj.Line (Btn.Left + Btn.width, Btn.Top + gTwips)-Step(0, Btn.height - gTwips), &HFFFFFF, B
    'bottom
    DrawObj.Line (Btn.Left + gTwips, Btn.Top + Btn.height)-Step(Btn.width - gTwips, 0), &HFFFFFF, B

      
    'handle automatic click up.....
    If IsMissing(BackUp) Then
        Btn.Status = 1 'down
    Else
        If BackUp Then
            StartTime = GetTickCount()
            DoEvents
            Do Until StartTime + 100 <= GetTickCount()
                If StartTime > GetTickCount Then Exit Do ' recycled the long
            Loop
        Else
            Btn.Status = 1
        End If
    End If
   
End Function
Function BtnUp(DrawObj As Object, Btn As Button, ImageIdx As Integer, BackObj As Object, Flat As Integer) As Integer

    Dim ImgX As Long, ImgY As Long, ImageTypePoint As Integer
    Dim DrawRect As RECT
'------------------------------------------------------------------------------------'
'Btn.Style: 0=icon,caption,backimg; 1=caption only; 2 = backimg,caption
'------------------------------------------------------------------------------------'

    gTwips = Screen.TwipsPerPixelX

    If Btn.Style = 1 Then
        DrawObj.Line (Btn.Left, Btn.Top)-Step(Btn.width, Btn.height), Btn.backcolor, BF 'grey button
    Else
        If Btn.ImgX <= 0 And Btn.Style = 0 Then
            ImageTypePoint = 0 '(fix later with states)
            'set image coords to pixels
            Btn.ImgX = (Btn.Left + (Btn.width - gBtnImg(ImageIdx).width) / 2) \ Screen.TwipsPerPixelX
            Btn.ImgY = (Btn.Top + ((Btn.height - (DrawObj.TextHeight(Btn.Caption) + 90)) - gBtnImg(ImageIdx).height) / 2) \ Screen.TwipsPerPixelY
        End If
        'draw background
        DrawObj.PaintPicture BackObj.Picture, Btn.Left, Btn.Top, Btn.width + TwipsX, Btn.height + TwipsY, 0, 0, Btn.width + TwipsX, Btn.height + TwipsY

    End If
    
    ' DrawCaption
    'set cap point on first pass
    If Btn.capX = 0 Then
        Btn.capX = Btn.Left + (Btn.width - DrawObj.TextWidth(Btn.Caption)) / 2 + gTwips
        If Btn.Style = 0 Then
            Btn.capY = Btn.Top + (Btn.height - (DrawObj.TextHeight(Btn.Caption) + 90)) + gTwips
        Else
            Btn.capY = Btn.Top + (Btn.height - DrawObj.TextHeight(Btn.Caption)) / 2
        End If
    End If
   
    If Btn.Enabled Then
        DrawObj.CurrentY = Btn.capY
        DrawObj.CurrentX = Btn.capX
        DrawObj.Print Btn.Caption
    Else
        DrawObj.CurrentY = Btn.capY + gTwips
        DrawObj.CurrentX = Btn.capX + gTwips
        DrawObj.ForeColor = &HFFFFFF
        DrawObj.Print Btn.Caption
        DrawObj.CurrentY = Btn.capY
        DrawObj.CurrentX = Btn.capX
        DrawObj.ForeColor = &H808080
        DrawObj.Print Btn.Caption
        DrawObj.ForeColor = &H0
    End If
   
    'draw icon image
    If Btn.Style = 0 Then
        If Btn.Enabled Then
            If Flat Then
                MutateBmp mode:=1, Dest:=DrawObj, Src:=gBtnImg(ImageIdx), destX:=Btn.ImgX, destY:=Btn.ImgY, BckColor:=&HC0C0C0
            Else
                MutateBmp mode:=4, Dest:=DrawObj, Src:=gBtnImg(ImageIdx), destX:=Btn.ImgX, destY:=Btn.ImgY, BckColor:=&HC0C0C0
            End If
        Else
            MutateBmp mode:=Btn.DisableStyle, Dest:=DrawObj, Src:=gBtnImg(ImageIdx), destX:=Btn.ImgX, destY:=Btn.ImgY, BckColor:=&HC0C0C0
        End If
    End If
   
    If Not Flat Then
        'draw light with box
        DrawObj.Line (Btn.Left, Btn.Top)-Step(Btn.width, Btn.height), &HC0C0C0, B
        DrawObj.Line (Btn.Left + gTwips, Btn.Top + gTwips)-Step(Btn.width - gTwips, Btn.height - gTwips), &HFFFFFF, B
        'draw dark
        'right
        DrawObj.Line (Btn.Left + Btn.width, Btn.Top + gTwips)-Step(0, Btn.height - gTwips), &H808080, B
        'bottom
        DrawObj.Line (Btn.Left + gTwips, Btn.Top + Btn.height)-Step(Btn.width - gTwips, 0), &H808080, B
    End If
   
    Btn.Status = Flat + 1
    
End Function
Public Sub MutateBmp(mode As Integer, Dest As Object, Src As Object, destX As Long, destY As Long, BckColor As Long)
Dim foo As Long, foobar As Long, Dummy As Long
Dim PicWidth As Long, PicHeight As Long, CtlHdc As Long

'Mode: 1=Remove colors, use existing black outline
'      3=Make grey/white disabled image from existing black pixels
'      4=Copy all colors, transparent
'Note: Src must be a picturebox with borderstyle 'none' and autoredraw true.
gTwips = Screen.TwipsPerPixelX
PicWidth = Src.width \ gTwips
PicHeight = Src.height \ gTwips
ReDim PicPixels(-1 To PicWidth, -1 To PicHeight) As Long

'load pixel array
CtlHdc = Src.hdc
For foobar = 0 To PicHeight - 1
    For foo = 0 To PicWidth - 1
        PicPixels(foo, foobar) = GetPixel(CtlHdc, foo, foobar)
    Next foo
Next foobar
CtlHdc = Dest.hdc
For foo = 0 To PicWidth - 1
   For foobar = 0 To PicHeight - 1
      Select Case mode
      Case 1 'remove color from existing black outline
         If PicPixels(foo, foobar) = &H0 Then
            Dummy = SetPixel(CtlHdc, destX + foo, destY + foobar, &H0&)
         End If
      Case 3 'Make grey/white disabled image from black outline
         If PicPixels(foo, foobar) = &H0 Then
            Dummy = SetPixel(CtlHdc, destX + foo, destY + foobar, &H808080)
            Dummy = SetPixel(CtlHdc, destX + foo + 1, destY + foobar + 1, &HFFFFFF)
            Dummy = SetPixel(CtlHdc, destX + foo + 1, destY + foobar, &HFFFFFF)
         End If
      Case 4 'Copy transparent
         If PicPixels(foo, foobar) <> BckColor Then
            Dummy = SetPixel(CtlHdc, destX + foo, destY + foobar, PicPixels(foo, foobar))
         End If
      End Select
   Next foobar
Next foo
If Dest.AutoRedraw Then Dest.Refresh
End Sub



Function BtnPoint(Btns() As Button, X As Single, Y As Single, ToolBarIdx As Integer) As Integer
    Dim foo As Integer

    BtnPoint = -1 'set up not found return value
    For foo = 0 To UBound(Btns)
        If X >= Btns(foo).Left And X <= Btns(foo).Left + Btns(foo).width _
            And Y >= Btns(foo).Top And Y <= Btns(foo).Top + Btns(foo).height _
            And ToolBarIdx = Btns(foo).ToolBarIndex Then
            If Btns(foo).Enabled Then
                BtnPoint = foo 'return valid index
            End If
            Exit Function
        End If
    Next foo
End Function
