Attribute VB_Name = "basBackgrounds"
Option Explicit

Public TwipsY As Integer, TwipsX As Integer
#If Win32 Then
   Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
#Else
   Declare Function GetDeviceCaps Lib "GDI" (ByVal hdc As Integer, ByVal nIndex As Integer) As Integer
#End If

Public Function MaxColors(Frm As Form) As Long
'this function uses any form to get a device context
Dim Bits As Long
Dim Planes As Integer
'first get bits per pixel
Bits = GetDeviceCaps(Frm.hdc, 12)
'next get number of color planes
Planes = GetDeviceCaps(Frm.hdc, 14)
'calculate max colors available
MaxColors = (2 ^ (Bits * Planes))

End Function
Public Sub ShadeRegion(DrawObj As Object, X As Long, Y As Long, width As Long, height As Long, Percent As Double)
Dim foo As Long, foobar As Long, CtlHdc As Long, checkit As Long

'Cache the hdc before entering the setpixel loop
CtlHdc = DrawObj.hdc

'loop through region
For foo = X To X + width Step TwipsX
   For foobar = Y To Y + height Step TwipsY
      checkit = SetPixel(CtlHdc, foo \ TwipsX, foobar \ TwipsY, ChangeShade(GetPixel(CtlHdc, foo \ TwipsX, foobar \ TwipsY), Percent))
   Next foobar
Next foo
If DrawObj.AutoRedraw Then DrawObj.Refresh

End Sub

Public Function ChangeShade(SrcRgb As Long, DegreeChange As Double) As Long
'DegreeChange: -1 to 1, where .5 = lighten 50%
Dim R As Long, G As Long, B As Long
Dim RMask As Long, GMask As Long, Bmask As Long
RMask = &HFF
GMask = &HFF00&
Bmask = &HFF0000

R = ((SrcRgb And RMask) * DegreeChange) + (SrcRgb And RMask)
If R > 255 Then R = 255
G = ((((SrcRgb And GMask) \ &H100) * DegreeChange)) + ((SrcRgb And GMask) \ &H100)
If G > 255 Then G = 255
B = ((((SrcRgb And Bmask) \ &H10000) * DegreeChange)) + ((SrcRgb And Bmask) \ &H10000)
If B > 255 Then B = 255

ChangeShade = RGB(R, G, B)

End Function

Public Sub TileToolbar(DrawObj As Object, Src As Object)
Dim foo As Integer, foobar As Integer

For foo = 0 To DrawObj.ScaleWidth Step Src.width
   DrawObj.PaintPicture Src.Picture, foo, 0, Src.width, Src.height
Next foo

End Sub
Public Sub TileBackground(DrawObj As Object, Src As Object, StartY As Long)
Dim foo As Integer, foobar As Integer

For foo = 0 To DrawObj.ScaleWidth Step Src.width - TwipsX
   For foobar = StartY To DrawObj.ScaleHeight Step Src.height
      DrawObj.PaintPicture Src.Picture, foo, foobar, Src.width, Src.height
   Next foobar
Next foo

End Sub

Public Sub TilePanel(DrawObj As Object, Src As Object, X As Long, Y As Long, width As Long, height As Long)
Dim foo As Integer, foobar As Integer
Dim ClipWidth As Long, ClipHeight As Long, SrcWidth As Long, SrcHeight As Long

SrcWidth = Src.width - TwipsX
SrcHeight = Src.height - TwipsY

For foo = X To X + width Step SrcWidth
   For foobar = Y To Y + height Step SrcHeight
      If foobar + SrcHeight <= Y + height Then
         ClipHeight = SrcHeight
      Else
         ClipHeight = Y + height - (foobar - TwipsY)
      End If
      If foo + SrcWidth <= X + width Then
         ClipWidth = SrcWidth
      Else
         ClipWidth = X + width - (foo - TwipsX)
      End If

      DrawObj.PaintPicture Src.Picture, foo, foobar, ClipWidth, ClipHeight, 0, 0, ClipWidth, ClipHeight

   Next foobar
Next foo

End Sub
Public Sub Draw3dFrame(DrawObj As Object, X As Long, Y As Long, width As Long, height, DarkShade As Long, LightShade As Long)

DrawObj.Line (X, Y)-Step(width, height), DarkShade, B
DrawObj.Line (width + X, Y)-Step(0, height + TwipsY), LightShade
DrawObj.Line (X, height + Y)-Step(width, 0), LightShade

End Sub
Public Sub Shade3dFrame(DrawObj As Object, X As Long, Y As Long, width As Long, height As Long, Percent As Double)
Dim foo As Long, foobar As Long, CtlHdc As Long, checkit As Long

'Cache the hdc before entering the setpixel loop
CtlHdc = DrawObj.hdc

'loop through lines
For foo = X To X + width Step TwipsX
   checkit = SetPixel(CtlHdc, foo \ TwipsX, Y \ TwipsY, ChangeShade(GetPixel(CtlHdc, foo \ TwipsX, Y \ TwipsY), Percent))
   checkit = SetPixel(CtlHdc, foo \ TwipsX, (Y + height) \ TwipsY, ChangeShade(GetPixel(CtlHdc, foo \ TwipsX, (Y + height) \ TwipsY), Percent * -1))
Next foo
For foobar = Y To Y + height Step TwipsY
   checkit = SetPixel(CtlHdc, X \ TwipsX, foobar \ TwipsY, ChangeShade(GetPixel(CtlHdc, X \ TwipsX, foobar \ TwipsY), Percent))
   checkit = SetPixel(CtlHdc, (X + width) \ TwipsX, foobar \ TwipsY, ChangeShade(GetPixel(CtlHdc, (X + width) \ TwipsX, foobar \ TwipsY), Percent * -1))
Next foobar
If DrawObj.AutoRedraw Then DrawObj.Refresh

End Sub
